<script lang="ts" setup>
import {
  AiCodeSuggestions,
  ChevronLgRight,
  Devsecops,
  MonitorPipeline,
  MonitorTest,
  Quote,
  ShieldCheckLight,
  SpeedGauge,
} from 'slippers-ui/icons';
import type { BaseLink } from '@/types/base';

interface Section {
  navigationTitle: string;
  title: string;
  description: string;
  quotes: {
    description: string;
    text: string;
    source: string;
    button: BaseLink;
    config: {
      icon: string;
    };
  }[];
}

interface TenReasons {
  items: Section[];
}

const props = defineProps<TenReasons>();

const icons = {
  AiCodeSuggestions,
  Devsecops,
  MonitorPipeline,
  MonitorTest,
  Quote,
  ShieldCheckLight,
  SpeedGauge,
};

const navigationItems = computed(() =>
  props.items.map(({ navigationTitle }, index) => ({
    text: `${String(index + 1).padStart(2, '0')} ${navigationTitle}`,
    id: `heading-${index + 1}`,
  })),
);
</script>

<template>
  <section class="ten-reasons">
    <SlpContainer>
      <SlpSideNavigation position="left" :dark-mode="true" :navigation-items="navigationItems">
        <div v-for="(item, index) in items" :key="item.title" class="slp-mb-160">
          <SlpTypography :id="`heading-${index + 1}`" tag="h2" variant="display1" class="gradient">
            {{ `0${index + 1}` }}
          </SlpTypography>
          <SlpTypography tag="h3" variant="heading2-bold">
            {{ item.title }}
          </SlpTypography>
          <SlpTypography class="slp-mt-32" tag="div" variant="heading5">
            <span v-html="$md.render(item.description)" />
          </SlpTypography>
          <div v-for="quote in item.quotes" :key="quote.text" class="quote">
            <div v-if="quote.logo?.config?.src || quote.logo?.fallbackText" class="quote__logo">
              <img v-if="quote.logo?.config?.src" :src="quote.logo.config.src" class="logo-item" />
              <SlpTypography v-else-if="quote.logo.fallbackText" variant="body1-bold" class="logo-item">
                {{ quote.logo.fallbackText }}
              </SlpTypography>
            </div>
            <div class="quote__content">
              <SlpTypography v-if="quote.description" tag="p" class="slp-mb-24" variant="body1">
                {{ quote.description }}
              </SlpTypography>
              <SlpIcon
                :icon="icons[quote.config.icon]"
                alt=""
                aria-hidden="true"
                size="lg"
                color="accent-400"
                class="slp-mb-16"
              />
              <SlpTypography tag="p" variant="quotes">
                {{ quote.text }}
              </SlpTypography>
              <SlpTypography v-if="quote.source" tag="p" variant="body2" class="slp-pt-16">
                {{ quote.source }}
              </SlpTypography>
              <SlpButton
                v-if="quote?.button?.text"
                :href="quote.button.config.href"
                variant="tertiary"
                class="quote__button"
                :data-ga-name="quote.button.dataGaName"
                :data-ga-location="quote.button.dataGaLocation"
              >
                {{ quote.button.text }}
                <SlpIcon :icon="ChevronLgRight" aria-hidden="true" alt="" size="sm" />
              </SlpButton>
            </div>
          </div>
        </div>
      </SlpSideNavigation>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.ten-reasons {
  padding-top: $spacing-32;

  &:deep(.side-navigation-content) {
    padding-left: 120px;

    @media (max-width: $breakpoint-lg) {
      padding: 0px;
    }
  }
}

.gradient {
  background: linear-gradient(90.27deg, #f9a026 -6.4%, #a686f2 8.01%, #592ac8 18.81%);
  -webkit-background-clip: text;
  background-clip: text;
  color: transparent;
}

.quote {
  display: flex;
  width: 100%;
  margin-top: $spacing-96;

  @media (max-width: $breakpoint-lg) {
    flex-direction: column-reverse;
  }

  &__logo {
    flex: 0 0 25%;
    max-width: 25%;
    align-self: flex-end;
    margin: 0px $spacing-24 $spacing-16 0px;
    display: flex;
    justify-content: flex-end;

    .logo-item {
      max-width: 200px;
    }

    @media (max-width: $breakpoint-lg) {
      align-self: flex-start;
      margin-top: $spacing-24;
      max-width: none;
    }
  }

  &__content {
    flex: 1;
    border: 1px solid $color-surface-600;
    border-radius: $border-radius-4;
    position: relative;
    padding: $spacing-32;
    min-width: 0;

    &:deep(.slp-text-quotes) {
      font-size: 20px;
      line-height: 32px;
    }

    &::before,
    &::after {
      content: '';
      position: absolute;
      left: -13px;
    }

    &::before {
      border-top: 13px solid transparent;
      border-bottom: 13px solid transparent;
      border-right: 13px solid $color-surface-600;
      bottom: 20px;
    }

    &::after {
      border-top: 11px solid transparent;
      border-bottom: 11px solid transparent;
      border-right: 11px solid $color-surface-700;
      bottom: 22px;
      transform: translateX(2px);
    }

    @media (max-width: $breakpoint-lg) {
      &::before,
      &::after {
        left: auto;
        bottom: auto;
        top: 100%;
        border-left: 13px solid transparent;
        border-right: 13px solid transparent;
        border-top-width: 0;
        border-bottom-width: 0;
      }

      &::before {
        border-top: 13px solid #45424d;
      }

      &::after {
        border-top: 12px solid #171321;
        left: 30px;
        transform: translateX(2px) translateY(-1px);
      }
    }
  }

  &__button {
    color: $color-text-50;
    margin-top: $spacing-32;
  }
}
</style>
